/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULATU_GRUPOPROJETO                                              */
/* Tabela : GRUPOPROJETO                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 26/11/2007 - Pedro Nerino Viol de Lima                                     */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULATU_GRUPOPROJETO
BEFORE INSERT OR UPDATE OR DELETE
ON GRUPOPROJETO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUGRPR := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF NVL(:OLD.NMGRUPOPROJ, 0) <> NVL(:NEW.NMGRUPOPROJ, 0) OR
         NVL(:OLD.CDGRUPOPER,  0) <> NVL(:NEW.CDGRUPOPER,  0) THEN
           :NEW.DTULTATUGRPR := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
         VALUES ('GRUPOPROJETO', '', 'CDGRUPOPROJ='||:OLD.CDGRUPOPROJ||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE GRUPOPROJETO MODIFY DTULTATUGRPR DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULATU_GRUPOPROJETO','5.01.001'); END;
/

