var Dfe36000_EntradasTransferenciaDoOperadorLogistico_Controller = function(Dfe36000_EntradasTransferenciaDoOperadorLogistico_Service, templateManager, ScreenService, General, ZhFilterPreferences){
    
    this.widgetOnEnterOnce = function(widget) {
        Dfe36000_EntradasTransferenciaDoOperadorLogistico_Service.getFilial().then((success) => {
            var row = Util.clone(widget.currentRow);
            if(success.dataset.filial[0].IDFUNCAOFILI == 'O') {
                row.CDOPERLOG = success.dataset.filial[0].CDFILIAL;
                row.NMOPERLOG = success.dataset.filial[0].NMFILIAL;
            }
            else {
                row.CDFILDEST = success.dataset.filial[0].CDFILIAL;
                row.NMFILDEST = success.dataset.filial[0].NMFILIAL;
            }
            var dataAtual = formatarData(new Date());
            row.DTENTRSAID = {start : dataAtual, end : dataAtual};
            
            ZhFilterPreferences.setOriginalFilter(widget.id, row);
            ZhFilterPreferences.openFilterWidget(widget, row);
        },
        (error) => {
            ZhFilterPreferences.openFilterWidget(widget);
            console.log(error);
        });
        
    };
    
    this.preparaFiltro = function(widget) {
        if(widget.appliedFilter) {
            Dfe36000_EntradasTransferenciaDoOperadorLogistico_Service.getParamGeral().then((success) => {
                let currentRow = widget.appliedFilter.FILTER_ROW;
                widget.dataSourceFilter = Dfe36000_EntradasTransferenciaDoOperadorLogistico_Service.buildFilter(["CDOPERLOG", "CDFILDEST", "CDSERIE", "NRNOTAFISC"], currentRow);
                widget.dataSourceFilter.push({name: "P_DTINI", operator: "=", value: currentRow.DTENTRSAID.start});
                widget.dataSourceFilter.push({name: "P_DTFIN", operator: "=", value: currentRow.DTENTRSAID.end});
                widget.dataSourceFilter.push({name: "P_CDOPERADOR", operator: "=", value: getLocalVar('CDOPERADOR')});
                widget.dataSourceFilter.push({name: "P_BLOQLANCNFOP", operator: "=", value: success.dataset.paramgeral[0].IDBLOQLANCNFOPFIL});
                widget.reload();
            });
        }
    };
    
    /*  Função para bloquear os fields filhos ligados a um field pai.
        Caso desbloqueiaComValor = true o field filho será habilitado 
        se o field pai possuir valor. No caso de valueDesbloqueia != null
        o valor para desbloquear o filho deve ser igual ao valor de valueDesbloqueia.
        
        @param field field 
    */
    this.alteraReadOnlyFilhos = function(field) {
        let widget = field.widget;
        field.filhos.forEach((filho) => {
            var desbloqueiaComValor = (filho.desbloqueiaComValor) ? filho.desbloqueiaComValor : true;
            var valueDesbloqueia    = (filho.valueDesbloqueia)    ? filho.valueDesbloqueia    : null;
            
            let filhoField = widget.getField(filho.name);
            if(valueDesbloqueia == null) {
                filhoField.readOnly =  ((field.value() == "") == desbloqueiaComValor);
                if(((field.value() == "") == desbloqueiaComValor)) widget.currentRow[filho.name] = "";
                if(filhoField.filhos) this.alteraReadOnlyFilhos(filhoField, true);
                widget.getField(filho.name).reload();
            }
            else {
                var habilita = (field.value() == valueDesbloqueia);
                if(habilita) {
                    if(filhoField.readOnly) {
                        if(filho.clearFields) {
                            filho.clearFields.forEach((clearField) => {
                                widget.currentRow[clearField] = "";
                            });
                        }
                        widget.currentRow[filho.name] = "";
                    }
                    
                    filhoField.readOnly = false;
                }
                else {
                    widget.currentRow[filho.name] = "";
                    filhoField.readOnly = true;
                }
                if(filhoField.filhos) this.alteraReadOnlyFilhos(filhoField, true);
                widget.getField(filho.name).reload();
            }
        });
    };

    /*
        Percorre uma widget procurando por fields com a propiedade "filhos".
        Para os fields com a propiedade fields a função adiciona o evento 
        de alteraReadOnlyFilhos.
        
        @param widget widget
        @param boolean filter
    */
    this.blockFieldsFilhosAndSetEvents = function(args, filter = true) {
        var widget = args.owner;
        let fields = widget.fields;
        fields.forEach((field) => {
            if(field.filhos) {
                field.events.push(
                    {
                        "name": "FieldOnChange",
                        "code": "Dfe36000_EntradasTransferenciaDoOperadorLogistico_Controller.alteraReadOnlyFilhos(args.owner.field)"
                    }
                );
                
                // field.filhos.forEach((filho) => {
                //     if(filter) widget.appliedFilter.getField(filho).readOnly = true; 
                //     else  widget.getField(filho).readOnly = true; 
                // });
            }
        });
    };
    
    this.openPopup = function() {
	    var widget = templateManager.container.getWidget('entrada_transfOpLogistico');
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": widget.appliedFilter.FILTER_ROW.CDFILDEST
            },
            {
                "name": "CDFILIOPELOG",
                "operator": "=",
                "value": widget.appliedFilter.FILTER_ROW.CDOPERLOG
            },
    	    {
        		"name": "ROWNUM",
        		"operator": "=",
        		"value": "1"
    	    }
        ];
        General.callRestEngine("df#/crud/paramprodsup", "FilterData", filter).then((success) => {
            var popUp = templateManager.container.getWidget('dadosGeracao');
            var nmTipoOper  = popUp.getField('NMTIPOOPER'); 
            if(success.dataset.paramprodsup[0]) {
                nmTipoOper.isVisible = false;
                delete(nmTipoOper.validations);
            } 
            else {
                nmTipoOper.isVisible = true;
                nmTipoOper.validations = {
                    "required": {
                        "message": "Obrigatório"
                    }  
                };
            }
            popUp.isVisible = true;
            ScreenService.openPopup(popUp);
            popUp.activate();
        });
    };
    
    this.closePopup = function(widget) {
        widget.isVisible = false;
        widget.dataSource.data = [];
        ScreenService.closePopup(widget);
        widget.getParent().activate();
        widget.getParent().unSelectAll();
        widget.getParent().reload();
        ScreenService.closePopup();
    };
    
    this.gerarEntrada = function(widget) {
        var widgetTransf = templateManager.container.getWidget('entrada_transfOpLogistico');
        var checkedRows = widgetTransf.getCheckedRows();
        checkedRows.forEach((row) => {
            row = Object.assign(row, widget.currentRow);
        });
        General.callRestEngine("df_entrada#/gerarEntradaOpl", "Row", checkedRows).then((success) => {
            this.closePopup(widget);
            ScreenService.successNotification(success.messages[0].message);
            if(success.dataset.errosGeracao[0]) this.openPopupErros(success.dataset.errosGeracao);
        });
    };
    
    this.openPopupErros = function(errosGeracao) {
        var widgetErros = templateManager.container.getWidget('errosGeracao');
        widgetErros.dataSource.data = errosGeracao;
        widgetErros.isVisible = true;
        ScreenService.openPopup(widgetErros);
        widgetErros.activate();
    };
    
    this.setDefaultFilter = function(widget) {
        Dfe36000_EntradasTransferenciaDoOperadorLogistico_Service.getFilial().then((success) => {
            if(success.dataset.filial[0].IDFUNCAOFILI == 'O') {
                widget.appliedFilter.FILTER_ROW.CDOPERLOG = success.dataset.filial[0].CDFILIAL;
                widget.appliedFilter.FILTER_ROW.NMOPERLOG = success.dataset.filial[0].NMFILIAL;
            }
            else {
                widget.appliedFilter.FILTER_ROW.CDFILIAL = success.dataset.filial[0].CDFILIAL;
                widget.appliedFilter.FILTER_ROW.NMFILIAL = success.dataset.filial[0].NMFILIAL;
            }
            var dataAtual = formatarData(new Date());
            widget.appliedFilter.FILTER_ROW.DTENTRSAID = {start : dataAtual, end : dataAtual};
        },
        (error) => {
            console.log(error);
        });
    };
    
    this.getFieldValueFilter = function(widget) {
        console.log(widget);  
    };
    
    function formatarData(data) {
        var d = new Date(data),
        mes = '' + (d.getMonth() + 1),
        dia = '' + d.getDate(),
        ano = d.getFullYear();
    
        if (mes.length < 2) mes = '0' + mes;
        if (dia.length < 2) dia = '0' + dia;
    
        return [dia, mes, ano].join('/');
    }
    
    this.getFieldValueFilter = function(fieldName) {
        if(templateManager.container) return templateManager.container.getActiveWidget().currentRow[fieldName];
    };
};

Configuration(function (ContextRegister){
    ContextRegister.register('Dfe36000_EntradasTransferenciaDoOperadorLogistico_Controller', Dfe36000_EntradasTransferenciaDoOperadorLogistico_Controller);
});
